/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.daos;


import com.tabajara.base.tables.Hisatuacao;
import com.tabajara.base.tables.records.HisatuacaoRecord;

import io.github.jklingsporn.vertx.jooq.shared.internal.AbstractVertxDAO;

import java.sql.Date;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Configuration;


import io.vertx.core.Future;
import io.github.jklingsporn.vertx.jooq.classic.jdbc.JDBCClassicQueryExecutor;
/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class HisatuacaoDao extends AbstractVertxDAO<HisatuacaoRecord, com.tabajara.base.tables.pojos.Hisatuacao, Integer, Future<List<com.tabajara.base.tables.pojos.Hisatuacao>>, Future<com.tabajara.base.tables.pojos.Hisatuacao>, Future<Integer>, Future<Integer>> implements io.github.jklingsporn.vertx.jooq.classic.VertxDAO<HisatuacaoRecord,com.tabajara.base.tables.pojos.Hisatuacao,Integer> {

    /**
     * @param configuration The Configuration used for rendering and query execution.
     * @param vertx the vertx instance
     */
    public HisatuacaoDao(Configuration configuration, io.vertx.core.Vertx vertx) {
        super(Hisatuacao.HISATUACAO, com.tabajara.base.tables.pojos.Hisatuacao.class, new JDBCClassicQueryExecutor<HisatuacaoRecord,com.tabajara.base.tables.pojos.Hisatuacao,Integer>(com.tabajara.base.tables.pojos.Hisatuacao.class,configuration,vertx), configuration);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected Integer getId(com.tabajara.base.tables.pojos.Hisatuacao object) {
        return object.getHistatuaid();
    }

    /**
     * Find records that have <code>fkardid IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Hisatuacao>> findManyByFkardid(List<Integer> values) {
        return findManyByCondition(Hisatuacao.HISATUACAO.FKARDID.in(values));
    }

    /**
     * Find records that have <code>fktanid IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Hisatuacao>> findManyByFktanid(List<Integer> values) {
        return findManyByCondition(Hisatuacao.HISATUACAO.FKTANID.in(values));
    }

    /**
     * Find records that have <code>fkatuid IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Hisatuacao>> findManyByFkatuid(List<Integer> values) {
        return findManyByCondition(Hisatuacao.HISATUACAO.FKATUID.in(values));
    }

    /**
     * Find records that have <code>fkempid IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Hisatuacao>> findManyByFkempid(List<Integer> values) {
        return findManyByCondition(Hisatuacao.HISATUACAO.FKEMPID.in(values));
    }

    /**
     * Find records that have <code>hora IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Hisatuacao>> findManyByHora(List<String> values) {
        return findManyByCondition(Hisatuacao.HISATUACAO.HORA.in(values));
    }

    /**
     * Find records that have <code>dia IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Hisatuacao>> findManyByDia(List<Date> values) {
        return findManyByCondition(Hisatuacao.HISATUACAO.DIA.in(values));
    }

    /**
     * Find records that have <code>medida IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Hisatuacao>> findManyByMedida(List<String> values) {
        return findManyByCondition(Hisatuacao.HISATUACAO.MEDIDA.in(values));
    }
}
